
//  RAztec
//  Copyright (C)
//
//  RReport@Confluencia.net
//  All rights reservedse
//
// Adquisition , use and distribution of this code is subject to restriction:
//  - You may modify the source code in order to adapt it to your needs.
//  - You may not copy and paste any code into external files.
//  - Redistribution of this ( or a modified version) source code is prohibited. You may only redistribute compiled versions.
//  - You may redistribute the compiled version as part of your application, not a new java component with the same purpose as this one.
//  - You may not remove this notice from the source code
//  - This notice disclaim all warranties of all material

import com.java4less.qrcode.*;
import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.awt.Graphics2D.*;
import java.awt.*;

public class QRCodeServlet  extends HttpServlet
    {


  public static void main(String[] a) {

  }


         private boolean debug=false;

        /**
         * Handle the HTTP POST method by sending an e-mail
         *
         *
         */

	    public void init() throws ServletException  {

	    }

       // read paramters form request an create barcode
       // http://localhost:8080/examples/servlet/RAztecServlet?DATA=AAADDEEE...
       public  QRCode getBarcode(HttpServletRequest request) {

       	 QRCode barcode=new  QRCode();


        // load parameters
         if (request!=null) {

            if (request.getParameter("DEBUG")!=null)
               if (request.getParameter("DEBUG").toUpperCase().compareTo("ON")==0) debug =true;

            java.util.Enumeration ps=request.getParameterNames();
            while (ps.hasMoreElements()) {
              String name=(String) ps.nextElement();

              // set parameters  of the barcode
              setParameter(name,request.getParameter(name),barcode);

              if (debug) System.out.println("PARAM: "+name+"="+request.getParameter(name));

            }
         }

         return barcode;

        }


         protected void setParameter(String p,String v,QRCode cb) {

         if (v==null) return;

          // READ DATA
          if (p.compareTo("DATA")==0)
            if (v!=null) cb.setCode(v);

          if (p.compareTo("FNC1_MODE")==0) {
            if (v!=null) {
              if (v.compareTo("FNC1_MODE_FIRST")==0) cb.setFnc1Mode(QRCode.FNC1_MODE_FIRST);
              if (v.compareTo("FNC1_MODE_SECOND")==0) cb.setFnc1Mode(QRCode.FNC1_MODE_SECOND);
            }
          }

          if (p.compareTo("APPLICATION_INDICATOR")==0)
            if (v!=null) cb.setApplicationIndicator((byte) Integer.parseInt(v));


          if (p.compareTo("PROCESSTILDE")==0)
            if (v!=null)
              if (v.compareTo("Y")==0) cb.setProcessTilde(true);
              else  cb.setProcessTilde(false);

          if (p.compareTo("ENCODING")==0) {
            cb.setEncoding(QRCode.ENC_AUTO);
            if (v!=null) {
              if (v.compareTo("NUMERIC")==0) cb.setEncoding(QRCode.ENC_NUMERIC);
              if (v.compareTo("BYTE")==0) cb.setEncoding(QRCode.ENC_BYTE);
              if (v.compareTo("ALPHA")==0) cb.setEncoding(QRCode.ENC_ALPHA);
              if (v.compareTo("KANJI")==0) cb.setEncoding(QRCode.ENC_KANJI);
            }
          }

          if (p.compareTo("ERROR_CORRECTION")==0) {
            if (v!=null) {
             if (v.compareTo("L")==0) cb.setErrorCorrectionLevel(QRCode.CORRECTION_LEVEL_L);
             if (v.compareTo("M")==0) cb.setErrorCorrectionLevel(QRCode.CORRECTION_LEVEL_M);
             if (v.compareTo("Q")==0) cb.setErrorCorrectionLevel(QRCode.CORRECTION_LEVEL_Q);
             if (v.compareTo("H")==0) cb.setErrorCorrectionLevel(QRCode.CORRECTION_LEVEL_H);
            }
          }

          if (p.compareTo("MODULE_SIZE")==0) {
             if (v!=null)
                    cb.setModuleSize(Integer.parseInt(v));
          }

          if (p.compareTo("MARGIN")==0) {
             if (v!=null)
                    cb.setMargin(Integer.parseInt(v));
          }

          if (p.compareTo("CONFIGURATION")==0) {
             if (v!=null)
                    cb.setPreferredVersion(Integer.parseInt(v));
          }

         if (p.compareTo("BAR_COLOR") == 0)  cb.setBarColor(convertColor(v));

         if (p.compareTo("BACK_COLOR") == 0)   cb.setBackColor(convertColor(v));


          if (p.compareTo("AUTOCONFIGURATE")==0)
            if (v!=null)
              if (v.compareTo("Y")==0) cb.setAutoConfigurate(true);
              else  cb.setAutoConfigurate(false);

          if (p.compareTo("STRUCTURED_APPEND_COUNTER")==0) {
             if (v!=null)
                    cb.setStructuredAppendCounter(Integer.parseInt(v));
          }

          if (p.compareTo("STRUCTURED_APPEND_INDEX")==0) {
             if (v!=null)
                    cb.setStructuredAppendIndex(Integer.parseInt(v));
          }

          if (p.compareTo("STRUCTURED_APPEND")==0)
            if (v!=null)
              if (v.compareTo("Y")==0) cb.setStructuredAppend(true);
              else  cb.setStructuredAppend(false);

          if (p.compareTo("ECI")==0) {
             if (v!=null)
                    cb.setECI(Integer.parseInt(v));
          }


       }

       // Handle a request
       // 1. create barcode
       // 2. draw barcode in a Buffered Image
       // 3. encode image as GIF or JPEG and send it to the browser
        public void doGet (HttpServletRequest request,
                	   HttpServletResponse response)
        throws ServletException, IOException
        {

               PrintWriter		out;
               ServletOutputStream outb;

              String encode="jpeg";

               if (request!=null) {
                 if (request.getParameter("FORMAT")!=null)  encode=request.getParameter("FORMAT").toLowerCase();

                 if ((encode.toLowerCase().compareTo("gif")!=0) && ((encode.toLowerCase().compareTo("png")!=0))) encode="jpeg";
               }

               response.setContentType("image/"+encode);

		//out=response.getWriter();
		outb=response.getOutputStream();

                // avoid caching in browser
		response.setHeader ("Pragma", "no-cache");
		response.setHeader ("Cache-Control", "no-cache");
		response.setDateHeader ("Expires",0);

               try { // Create buffer


               int w=400;
               int h=200;


               if (request!=null) {
                 if (request.getParameter("WIDTH")!=null) w=new Integer(request.getParameter("WIDTH")).intValue();
                 if (request.getParameter("HEIGHT")!=null) h=new Integer(request.getParameter("HEIGHT")).intValue();
               }

		java.awt.image.BufferedImage BarImage=new java.awt.image.BufferedImage(w,h,java.awt.image.BufferedImage.TYPE_INT_RGB);
		java.awt.Graphics2D BarGraphics=BarImage.createGraphics();

                // get BarCode
                QRCode cb=getBarcode(request);

                 if (debug) System.out.println("Size: "+w+" "+h);
                cb.setSize(w,h);

                cb.setRedraw(true);
                cb.paint(BarGraphics);

               if (encode.toLowerCase().compareTo("gif")==0) {
                 // download gif encoder from http://www.acme.com/resources/classes/Acme.tar.gz
                 // encode buffered image to a gif

                   Class enClass=Class.forName("Acme.JPM.Encoders.GifEncoder");
                   Class[] constructorParams = new Class[2];
                   constructorParams[0]=Class.forName("java.awt.Image");
                   constructorParams[1]=Class.forName("java.io.OutputStream");
                   Object[] constructorObj = new Object[2];
                   constructorObj[0]=BarImage;
                   constructorObj[1]=outb;

                   Object encoder= enClass.getConstructor(constructorParams).newInstance(constructorObj);

                    Class[] encodeParams = new Class[0];
                    Object[] encodeObj = new Object[0];

                    enClass.getMethod("encode",encodeParams).invoke(encoder,encodeObj);

                 // Acme.JPM.Encoders.GifEncoder encoder = new Acme.JPM.Encoders.GifEncoder(BarImage  ,outb);
                 // encoder.encode();
                }
                else
                if (encode.toLowerCase().compareTo("png")==0) {
                    // download from http://users.boone.net/wbrameld/pngencoder/

                  Class enClass=Class.forName("com.bigfoot.bugar.image.PNGEncoder");
                   Class[] constructorParams = new Class[2];
                   constructorParams[0]=Class.forName("java.awt.Image");
                   constructorParams[1]=Class.forName("java.io.OutputStream");
                   Object[] constructorObj = new Object[2];
                   constructorObj[0]=BarImage;
                   constructorObj[1]=outb;

                   Object encoder= enClass.getConstructor(constructorParams).newInstance(constructorObj);

                    Class[] encodeParams = new Class[0];
                    Object[] encodeObj = new Object[0];

                    enClass.getMethod("encodeImage",encodeParams).invoke(encoder,encodeObj);


                    //com.bigfoot.bugar.image.PNGEncoder en= new com.bigfoot.bugar.image.PNGEncoder(BarImage  ,outb);
                    //en.encodeImage();
                }
                else {
                  // create JPEG image
                  com.sun.image.codec.jpeg.JPEGImageEncoder encoder = com.sun.image.codec.jpeg.JPEGCodec.createJPEGEncoder(outb );
                  encoder.encode( BarImage );
                }

              } catch (Exception e) { e.printStackTrace();}

	}


// function to convert a String parameter to a color
  protected java.awt.Color convertColor(String c) {
	if (c.compareTo("NULL")==0) return null;
    if (c.compareTo("RED")==0) return java.awt.Color.red;
    if (c.compareTo("BLACK")==0) return java.awt.Color.black;
    if (c.compareTo("BLUE")==0) return java.awt.Color.blue;
    if (c.compareTo("CYAN")==0) return java.awt.Color.cyan;
    if (c.compareTo("DARKGRAY")==0) return java.awt.Color.darkGray;
    if (c.compareTo("GRAY")==0) return java.awt.Color.gray;
    if (c.compareTo("GREEN")==0) return java.awt.Color.green;
    if (c.compareTo("LIGHTGRAY")==0) return java.awt.Color.lightGray;
    if (c.compareTo("MAGENTA")==0) return java.awt.Color.magenta;
    if (c.compareTo("ORANGE")==0) return java.awt.Color.orange;
    if (c.compareTo("PINK")==0) return java.awt.Color.pink;
    if (c.compareTo("WHITE")==0) return java.awt.Color.white;
    if (c.compareTo("YELLOW")==0) return java.awt.Color.yellow;
    try {
       return java.awt.Color.decode(c);
    } catch (Exception e) {return java.awt.Color.black;}
  }


        public void doPost (HttpServletRequest request,
                	   HttpServletResponse response)
        throws ServletException
        {
        try {
            doGet(request,response);
            } catch (Exception e) { e.printStackTrace();}
	}

    }


